import AIR.RunwayPackage.*;
import AIR.*;
import org.omg.CORBA.*;
//import com.ooc.CORBA.*;
import java.io.*;
import java.util.*;
import java.math.*;

public class _AirportImplBaseNew extends _AirportImplBase {

   static final int GRASS = 0;
   static final int CONCRETE = 1;
   static InfoBase base; 	
   static World world;
   private String name;
   private String picture;
   private boolean hasILS;
   private Position location; // pozice letiste
   private _RunwayImplBaseNew runways[]; // seznam (prave provozuschopnych) drah
   private Vector landedAircrafts = new Vector(); // seznam letadel v hangarech (pro dispecera)
   private _RadarImplBaseNew radar;
   private Storage storage;
   private Aircraft[] is_runway_free;
   
   public static void main(String args[]) {
		world = null;
		// Create ORB
		ORB orb=ORB.init (args, new java.util.Properties());
		BOA boa = orb.BOA_init(args,new java.util.Properties());
		// Get World object reference
		String ref = null;
		try {
			String refFile=args[0];
			BufferedReader in=
				new BufferedReader(new FileReader(refFile));
			ref = in.readLine();
			org.omg.CORBA.Object obj = orb.string_to_object(ref);
			if (obj == null) {
				System.err.println("World_client: Invalid reference to World.");
				System.exit(1);
			} else {
				// Create reference to World object
				world = WorldHelper.narrow(obj);
			}    		
		} catch (IOException ex) {
			System.err.println("Can't read from World.ref file.");
			System.exit(1);
		}

                ((com.ooc.CORBA.ORB)orb).conc_model(com.ooc.CORBA.ORB.ConcModel.ConcModelThreaded);
                ((com.ooc.CORBA.BOA)boa).conc_model(com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPerRequest);
                ((com.ooc.CORBA.BOA)boa).init_servers();

                base = world.getInfoBase();
                String[] name_airports = base.getValue("airport");
                int airport_count = name_airports.length;
                for (int a = 0; a < airport_count; ++a)
                   world.addAirport(new _AirportImplBaseNew(name_airports[a], world));

                while(true) Thread.yield();
   }

   public _AirportImplBaseNew(String name_airport, World world) {
      
      String bvar;
      int rways_count;
      float rway_leng;
      String rway_surf;
      String[] variables;
      final int runway_count;
      String[] rways;
      float x, y ,z;
      
      variables = base.getValue("airport." + name_airport);
      this.name = name_airport;
      this.picture = base.getValue("airport." + name_airport + ".picture")[0];
      bvar = base.getValue("airport." + name_airport + ".hasILS")[0];
      if (bvar.equals("true")) this.hasILS = true;
      else this.hasILS = false;
      x = new Float(base.getValue("airport." + name_airport + ".x")[0]).floatValue();
      y = new Float(base.getValue("airport." + name_airport + ".y")[0]).floatValue();
      z = new Float(base.getValue("airport." + name_airport + ".altitude")[0]).floatValue();
      this.location = new Position(x ,y, z);
      
      rways = base.getValue("airport." + name_airport + ".runway");
      rways_count = rways.length;
      runways = new _RunwayImplBaseNew[rways_count];
      is_runway_free = new Aircraft[rways_count];
      for (int b = 0; b < rways_count; ++b) {
         rway_leng = new Float(base.getValue("airport." + name_airport + ".runway." + rways[b] +  ".length")[0]).floatValue();
         rway_surf = base.getValue("airport." + name_airport + ".runway."  + rways[b] + ".surface")[0];
         this.runways[b] = new _RunwayImplBaseNew(rway_leng, rway_surf);
         is_runway_free[b] = null;
      }
      this.radar = new _RadarImplBaseNew((double) 1000.0, location.longitude, location.latitude, location.altitude, world);
      this.storage = (world.getStorageFactory()).getNewStorage((float) -2, (short) -2);
      try {
      storage.load(world.getTransportableFactory().getNewBox("BALIK", (short) 1, (float) 10));
      }
      catch (StorageFullException e) {}
         
      System.out.println("Inicializuji letiste " + name_airport);
}



        public void newAircraft(Aircraft newPlane) {
        // metoda pro pridavani novych letadel do systemu.
        // Letiste naplni do letadla palivo.
           //String aa = newPlane.getType();
           //System.out.println("... jmeno letadla: " + aa);
           //float bb = (float) 100000;//new Float(base.getValue("aircraft." + aa + ".fuelTankCapacity")[0]).floatValue();
           //System.out.println("... tankuju [l] : " + bb);
           //newPlane.setFuel(bb);
           //newPlane.setFuel(new Float(base.getValue("aircraft." + aa + ".fuelTypeCapacity")[0]).floatValue());
           System.out.println("Na letiste " + this.name + " bylo pridano nove letadlo " + newPlane.getName());
           System.out.println("Zkousim tankovat ...");
           newPlane.setFuel(new Float(base.getValue("aircraft." + newPlane.getType() + ".fuelTankCapacity")[0]).floatValue());
           landedAircrafts.addElement(newPlane);
           System.out.println("Soucasny pocet letadel v hangaru : " + landedAircrafts.size());
        }

        public WeatherReport getWeather() {
           System.out.print(".");
           //WeatherReport ww = world.getWeather(location);
           //System.out.println("... tak jsem mu ho dal");
           //return ww;
           return world.getWeather(location);
             //boolean hasILS();
             
        // ILS=Instrumental Landing System; je-li tam, muze letadlo
        // vybavene ILS pristat i za nulove viditelnosti.
        }
             
        public int getLandingClearance(Aircraft aircraft, boolean emergency)
        throws  RunwayReachabilityException { //dalekoisibilityException
	// letadlo  musi hlidat  cas od zadosi a  testovat,
	// zda  se neztratila, pripadne opakovat. Letiste musi poznat
        // opakovanou zadost tehoz letadla
        // Vraci odhadovanou dobu k prideleni povoleni. Zadost lze
        // zrusit cancelLanding();

        Vector on_radar = radar.getAircrafts();
        for (int el = 0; el < on_radar.size(); ++el)
           if( (( (Aircraft) (on_radar.elementAt(el) )).getName()).equals(aircraft.getName()))
              break;
           else if (el == on_radar.size()) {
              System.out.println("Letadlo neni videt na radaru !");
              throw new RunwayReachabilityException("Vyjimka v getLandingClearance()");
           }


        if (on_radar.contains(aircraft)) {
           System.out.println("Letadlo neni videt na radaru !");
           throw new RunwayReachabilityException("Vyjimka v getLandingClearance()");
        }
	int air_surf = Integer.parseInt(base.getValue("aircraft." + aircraft.getType() + ".runwaySurface")[0]);
	float need_length = new Float(base.getValue("aircraft." + aircraft.getType() + ".runwayLength")[0]).floatValue();
	for (int i = 0; i < runways.length; ++i)
           if (runways[i].getSurface().value() == air_surf &&
		    runways[i].getLength() >= need_length &&
		    is_runway_free[i] == null		) {
			is_runway_free[i] = aircraft;
			aircraft.land(runways[i]);
			System.out.println("Letadlo " + aircraft.getName() + " dostalo povoleni k pristani na runway" + i + " letiste " + name);
			break;
		}
           else {
              System.out.println("Neni dostupna vhodna runway pro pristani !");
              throw new RunwayReachabilityException("Vyjimka v getLandingClearance()");
           }
        return 10; 
        }
        
        public int getTakeOffClearance(Aircraft aircraft)
        throws RunwayReachabilityException, VisibilityException {

           //System.out.println("Pocet letadel v hangaru pred odletem: " + landedAircrafts.size());
           //if (landedAircrafts.contains(aircraft) == false)
		//throw new RunwayReachabilityException("Vyjimka v getTakeoffClearence()");
	int air_surf = Integer.parseInt(base.getValue("aircraft." + aircraft.getType() + ".runwaySurface")[0]);
        float need_length = new Float(base.getValue("aircraft." + aircraft.getType() + ".runwayLength")[0]).floatValue();
	for (int i = 0; i < runways.length; ++i)
		if (runways[i].getSurface().value() == air_surf &&
		    runways[i].getLength() >= need_length &&
		    is_runway_free[i] == null		) {
			//is_runway_free[i] == aircraft;

                   for (int el = 0; el < landedAircrafts.size(); ++el)
                      if( (( (Aircraft) (landedAircrafts.elementAt(el) )).getName()).equals(aircraft.getName())) {
                         landedAircrafts.removeElementAt(el);
                         break;
                      }
		   aircraft.takeOff(runways[i]);
		   System.out.println("Letadlo " + aircraft.getName() + " dostalo povoleni k odletu z runway" + i + " letiste " + name);
		   break;
		}
                else {
                   System.out.println("Neni dostupna vhodna runway pro vzletnuti !");
                   throw new RunwayReachabilityException("Vyjimka v getTakeOffClearence()");
                }
        System.out.println("Pocet letadel v hangaru po odletu: " + landedAircrafts.size());
        return 10;

        }
      
        public void landed(Aircraft aircraft) {
		for(int i = 0; i < is_runway_free.length; ++i)
			if( (is_runway_free[i].getName()).equals(aircraft.getName()) ) {
				is_runway_free[i] = null;
				break;
			}

                landedAircrafts.addElement(aircraft);
                System.out.println("Letadlo " + aircraft.getName() + " prave pristalo na letisti v " + this.name);
                System.out.println("Tankuju ho do plneho ...");
                aircraft.setFuel(new Float(base.getValue("aircraft." + aircraft.getType() + ".fuelTankCapacity")[0]).floatValue());
                System.out.println("Novy pocet letadel v hangaru: " + landedAircrafts.size());
                //System.out.println("... jmeno letadla: " + aa);
                //float bb = (float) 100000;//new Float(base.getValue("aircraft." + aa + ".fuelTankCapacity")[0]).floatValue();
                //System.out.println("... tankuju [l] : " + bb);
                //aircraft.setFuel((float) 1000000);

                Transportable[] tir1 = aircraft.unload(this);
                for (int i = 0; i < tir1.length; ++i)
                   try {
                      storage.load(tir1[i]);
                   }
                catch (StorageFullException e) {}
                FlightStage[] stace = aircraft.getFlightPlan();
                for(int k = 0; k < stace.length; ++k) {
                   Transportable[] tir2 = storage.unload(stace[k].nextAirport);
                   for(int l = 0; l < tir2.length; ++l) {
                      try {
                         aircraft.load(tir2[l]);
                      }
                      catch (StorageFullException e) {}
                   }
                }
                
        }

        public void cancelLanding(Aircraft aircraft) {
        // zruseni pozadavku na pristani (pred i po jeho povolenim,
        // tedy letadlo smi volat i po land() )
		System.out.println("Letadlo " + aircraft.getName() + " zrusilo pristavaci manevr.");
		for(int i = 0; i < is_runway_free.length; ++i)
			if( is_runway_free[i] == aircraft) {
				is_runway_free[i] = null;
				break;
			}
        }

        public String name() {
           return name;
        }

        public Position location() {
           return location;
        }

        public Aircraft[] landedAircrafts() {
           Aircraft[] aero = new Aircraft[landedAircrafts.size()];
           landedAircrafts.copyInto(aero);
           return aero;
        }

        public Runway[] runways() {
           return runways;
        }

        public boolean hasILS() {
           return hasILS;
        }

        

        public void load(Transportable t) throws StorageFullException {
           try {
              storage.load(t);
           }
           catch (StorageFullException e) {throw new StorageFullException();}
	}

        public float maxLoad() {
           return storage.maxLoad();
        }

        public short numPersons() {
           return storage.numPersons();
        }
        
	public Transportable[] unload(Airport where) {
		return storage.unload(where);
	}

	public Transportable[] contents() {
		return storage.contents();
	}

	public boolean isEmpty() {
		return storage.isEmpty();
	}

	public void moveContentsTo(Storage dest) throws StorageFullException {
		storage.moveContentsTo(dest);
	}
	
	public Airport[] getDestinationList() {
		return storage.getDestinationList();
	}

	public short getMaxPriority() {
		return storage.getMaxPriority();
	}

	
	
}	